<?php 


	/*
		Exmaple: Query a transaction in Cuepay
		Author: Freeman Global Solutions
		Date: October 2, 2017
	 */
	

	/* Extract reference from Cuepay via POST */


	$reference = isset($_POST['reference']) ? $_POST['reference']: null;


	/* If null, then nothing has been submitted from Cuepay */


	if($reference == null) { exit; } 


	/* Set your Cuepay merchant id */

	$merchant = '10000000';


	/* Set your Cuepay secret */

	$secret   = 'father';


	/* Set the expected transaction amount if you have it. This is optional */

	$amount   = null;


	/* Generate request token  */

	$token    =  hash ('sha512', $merchant.$reference.$secret);


	/* Url encode data. Note: include ( 'amount' => $amount ) if you have it */

	$query    = http_build_query( array('merchant'=>$merchant, 'reference'=>$reference, 'token'=>$token) );


	/* Construct request Url */

	$request  = 'https://cuepay.com/secure/query/?'.$query;


	/* Execute the request; and convert to the JSON result to object */

	$response = json_decode( file_get_contents($request) );


	/*  If response is null, then something is not right. */

	if($response == null)
	{
		echo 'Could not query transaction'; exit;
	}


	/* Check the status of the transaction */


	if($response->status === 'success' && $response->code === '00')
	{

		/* Provide value to customer here */
	}
	else
	{
		/* Transaction declined/cancelled/in-doubt */
	}


	echo 'Transaction Status: '. ucfirst($response->status);



?>